# https://docs.python.org/3/distutils/apiref.html#distutils.core.Extension

from distutils.core import setup, Extension

module1 = Extension(
  name = 'bignum',
  sources = ['bignum.c'],
  libraries = ['crypto'],
  library_dirs = ['/opt/openssl/lib'],
  include_dirs = ['/opt/openssl/include'],
  extra_compile_args = ['--std=c11']
)

setup(
  name = 'bignum',
  version = '1.05',
  description = 'openssl bignum prime routines',
  ext_modules = [module1]
)

