# factor() from http://anh.cs.luc.edu/331/code/factoring.py
# use only for checking small primes ~< 64 bits
#
def factor(n, startFrom=2):
    """returns a list of prime factors of n,
    knowing min possible >= startFrom."""
    if n <= 1:  return [ ]
    d = startFrom
    factors = [ ]
    while n >= d*d:
      if n % d == 0:
        factors.append(d)
#        n = n/d
# RP:
        n = n//d
      else:
        d += 1 + d % 2  # 2 -> 3, odd -> odd + 2
    factors.append(n)
    return factors


# callback functions should return 1 to continue, 0 to stop
# returning 0 will make it crash, e.g.: RuntimeError: BN_is_prime_ex() failed
#
def callback( a, b, c):
  print( "PY callback:", a, b, c)
  return 1


# some simple tests
#
from bignum import *

tests = [ "generate_prime(32)", "", "is_prime(p)", "factor(p)",
	  "is_prime(123)", "is_prime(p,5,cb=callback,cb_arg='xyz')",
	  "generate_prime(128,1,24,11)", "", "is_prime((p-1)//2)", "p % 24",
	  "mod_inverse(11,p)", "(r*11)%p", "mod_inverse(5,9)", "mod_inverse(9,5)" ]

# main
#
if __name__ == '__main__':

  for test in tests:
    if test == "": # save result in p
      print( "p = r")
      p = r
    else:
      print( "r =", test)
      r = eval(test)
      print( r)
